#!/bin/sh
#############################################################################
# generate files used for database transfer
#
# files.txt commands.txt
#############################################################################
#
# Setup list of Databases / Directories / ... 
#
#############################################################################
database=""
database="$database DiversityCollection_BIOTA-S04"
database="$database DiversityDescriptions_LIASlight"
database="$database DiversityDescriptions_BIOTA-S04"
database="$database DiversityNames_LIAS"
database="$database DiversityPhylogeny_Mycophylogeny"
# database="$database DiversityLinks_MycologyNet"
# database="$database DiversityLinks_PhycologyNet"
#
from_dir="/cygdrive/e/DBUpload/"
to_dir="/DBUpload/"
#
transfer_file_name="transfer.tgz"
sql_file_name="*.Postgres"
#
# Write File-Header
#
file_file="files.txt"
#
echo "############################################################################" > ${file_file}
echo "# The structure of this file is :                                          #" >>${file_file}
echo "# - The meaning of the fileds are : is l2r (localhost to remote) and r2l   #" >>${file_file}
echo "# (remote computer to local).                                              #" >>${file_file}
echo "#       r2l  file1   file2                                                 #" >>${file_file}
echo "#         means copy file1 from remote (hosts specified in the             #" >>${file_file}
echo "#         hosts.txt file) computer to localhost as file2.                  #" >>${file_file}
echo "#       l2r     file1   file2                                              #" >>${file_file}
echo "#         means copy file1 from localhost to                               #" >>${file_file}
echo "#         remote (hosts specified in the hosts.txt file) computer as file2 #" >>${file_file}
echo "#         file1 and file2 are files on the corrsponding hosts.             #" >>${file_file}
echo "#                                                                          #" >>${file_file}
echo "#       Note: the order of using local and remote specifies the direction  #" >>${file_file}
echo "#       of the copy process.                                               #" >>${file_file}
echo "############################################################################" >>${file_file}
#
# copy XML-Export file form remote-server BSM4 (Windows) 
#
for i in ${database}
do
#    echo "r2l	${from_dir}${i}/XML/${transfer_file_name}	${to_dir}${i}/XML/${transfer_file_name}"  >>${file_file}
#
#
#
    echo "r2l	${from_dir}${i}/${transfer_file_name}	${to_dir}${i}/${transfer_file_name}"  >>${file_file}
#
# Postgres SQL-Model
#
    echo "r2l	${from_dir}${i}/Doku/${sql_file_name}	${to_dir}${i}/Doku/."  >>${file_file}
done
#
############################################################################################
# local commands
############################################################################################
local_command_file_name="local_commands.txt"
#
echo "###########################################################################"  >${local_command_file_name}
echo "# The structure of this file is : Every line contains a command to be     #" >>${local_command_file_name}
echo "#  executed. Every command is treated seperately.                         #" >>${local_command_file_name}
echo "###########################################################################" >>${local_command_file_name}
#
for i in ${database}
do
    echo "tar -C ${to_dir}${i} -xvzf ${to_dir}${i}/${transfer_file_name}"  >>${local_command_file_name}
done
#
#
# 
#
############################################################################################
# remote commands
############################################################################################
remote_command_file_name="remote_commands.txt"
#
echo "###########################################################################"  >${remote_command_file_name}
echo "# The structure of this file is : Every line contains a command to be     #" >>${remote_command_file_name}
echo "#  executed. Every command is treated seperately.                         #" >>${remote_command_file_name}
echo "###########################################################################" >>${remote_command_file_name}
#
for i in ${database}
do
    echo "tar -C ${from_dir}${i} -cvzf ${from_dir}${i}/${transfer_file_name} XML"  >>${remote_command_file_name}
done
#
############################################################################################
# Script for database creation
############################################################################################
#
db_file_name="db.sh"
#
#
echo "#!/bin/sh" >${db_file_name}
#
for i in ${database}
do
    echo "dropdb ${i}"  >>${db_file_name}
    echo "createdb -E UNICODE ${i}"  >>${db_file_name}
    echo "psql ${i} -f ${i}.sql"  >>${db_file_name}
    echo "#"  >>${db_file_name}
done
#
############################################################################################
# Script for local directories
############################################################################################
dir_file_name="create_local_directories.sh"
#
#
echo "#!/bin/sh" >${dir_file_name}
#
echo "cd /"  >>${dir_file_name}
#
echo "mkdir ${to_dir}" >>${dir_file_name}
for i in ${database}
do
    echo "mkdir ${to_dir}${i}"  >>${dir_file_name}
    echo "mkdir ${to_dir}${i}/XML"  >>${dir_file_name}
    echo "mkdir ${to_dir}${i}/Doku"  >>${dir_file_name}
done
#
echo "chown -R didi:users ${to_dir}"  >>${dir_file_name}
chmod 700 ${dir_file_name}
############################################################################################
# Script for remote directories
############################################################################################
dir_file_name="create_remote_directories.sh"
#
#
echo "#!/bin/sh" >${dir_file_name}
#
echo "cd /" >>${dir_file_name}
#
echo "mkdir ${from_dir}" >>${dir_file_name}
for i in ${database}
do
    echo "mkdir ${from_dir}${i}"  >>${dir_file_name}
    echo "mkdir ${from_dir}${i}/XML"  >>${dir_file_name}
    echo "mkdir ${from_dir}${i}/Doku"  >>${dir_file_name}
done
#
echo "chown -R didi:users ${from_dir}"  >>${dir_file_name}
#
chmod 700 ${dir_file_name}
############################################################################################
# database import script
############################################################################################

cp="./jar/diversity_navigator.jar:./jar/jdom-b9.jar:./jar/pg73jdbc3.jar"

for i in ${database}
do
    import_script="${i}.import.sh"
    echo "#!/bin/sh"                                                 >${import_script}
    echo "cp=${cp}"                                                 >>${import_script}
    echo "#"                                                        >>${import_script}
    echo "# Set Database URL"                                       >>${import_script}
    echo "#"                                                        >>${import_script}
    echo "DATABASE_URL=jdbc:postgresql://localhost:5432/${i}"       >>${import_script}
    echo "#"                                                        >>${import_script}
    echo "# Set Database user"                                      >>${import_script}
    echo "#"                                                        >>${import_script}
    echo "DATABASE_USER=\"didi\""                                   >>${import_script}
    echo "#"                                                        >>${import_script}
    echo "# Set Database passwd"                                    >>${import_script}
    echo "#"                                                        >>${import_script}
    echo "DATABASE_PWD=\"\\\"\\\"\""                                    >>${import_script}
    echo "#"                                                        >>${import_script}
    echo "# Set Import Directory"                                   >>${import_script}
    echo "#"                                                        >>${import_script}
    echo "IMPORT_DIR=${to_dir}${i}/XML"                             >>${import_script}
    echo "# memory settings"                                        >>${import_script}
    echo ""                                                         >>${import_script}
    echo "# -Xms<size> set initial Java heap size, The default value is 2MB"   >>${import_script}
    echo "memset=\"-Xms16m\""                                       >>${import_script}
    echo "#-Xmx<size> set maximum Java heap size, The default value is 64MB"    >>${import_script}
    echo "memset=\"$memset -Xmx256m\""                              >>${import_script}
    echo "#-Xss<size> set java thread stack size"                   >>${import_script}
    echo "echo \"memory settings: \$memset\""                       >>${import_script}
    echo ""                                                         >>${import_script}
    echo "# Import Table-Data into database"                        >>${import_script}
    echo "##############################"                           >>${import_script}
    echo "# database tables             "                           >>${import_script}
    echo "##############################"                           >>${import_script}
    echo "import_files=\"${i}.import.tables.txt\""                  >>${import_script}
    echo "cat \$import_files | grep -v \"#\" | while read -r table" >>${import_script}
    echo "do"                                                       >>${import_script}
    echo "   java $memset -cp \$cp net.metadiversity.diversity.navigator.util.ImportMsDbTable \"\$DATABASE_URL\" \$DATABASE_USER \$DATABASE_PWD \"\$IMPORT_DIR/\${table}\""                       >>${import_script}
    echo "done"                				      >>${import_script}


    chmod 700 ${import_script}
done
#########################################################################################